OpenSessionInViewFilter (Spring Framework 3.2.1.RELEASE API)
Date: 2013-01-24

org.springframework.orm.hibernate3.support

## Class OpenSessionInViewFilter

- java.lang.Object
- - org.springframework.web.filter.GenericFilterBean
  - - org.springframework.web.filter.OncePerRequestFilter
    - - org.springframework.orm.hibernate3.support.OpenSessionInViewFilter

- All Implemented Interfaces:
    Filter, Aware, BeanNameAware, DisposableBean, InitializingBean, EnvironmentAware, ServletContextAware

      public class OpenSessionInViewFilter
      extends OncePerRequestFilter

  Servlet 2.3 Filter that binds a Hibernate Session to the thread for the entire processing of the request. Intended for the "Open Session in View" pattern, i.e. to allow for lazy loading in web views despite the original transactions already being completed.

  This filter makes Hibernate Sessions available via the current thread, which will be autodetected by transaction managers. It is suitable for service layer transactions via `HibernateTransactionManager` or `JtaTransactionManager` as well as for non-transactional execution (if configured appropriately).

  NOTE: This filter will by default not flush the Hibernate Session, with the flush mode set to `FlushMode.NEVER`. It assumes to be used in combination with service layer transactions that care for the flushing: The active transaction manager will temporarily change the flush mode to `FlushMode.AUTO` during a read-write transaction, with the flush mode reset to `FlushMode.NEVER` at the end of each transaction. If you intend to use this filter without transactions, consider changing the default flush mode (through the "flushMode" property).

  WARNING: Applying this filter to existing logic can cause issues that have not appeared before, through the use of a single Hibernate Session for the processing of an entire request. In particular, the reassociation of persistent objects with a Hibernate Session has to occur at the very beginning of request processing, to avoid clashes with already loaded instances of the same objects.

  Alternatively, turn this filter into deferred close mode, by specifying "singleSession"="false": It will not use a single session per request then, but rather let each data access operation or transaction use its own session (like without Open Session in View). Each of those sessions will be registered for deferred close, though, actually processed at request completion.

  A single session per request allows for most efficient first-level caching, but can cause side effects, for example on `saveOrUpdate` or when continuing after a rolled-back transaction. The deferred close strategy is as safe as no Open Session in View in that respect, while still allowing for lazy loading in views (but not providing a first-level cache for the entire request).

  Looks up the SessionFactory in Spring's root web application context. Supports a "sessionFactoryBeanName" filter init-param in `web.xml`; the default bean name is "sessionFactory". Looks up the SessionFactory on each request, to avoid initialization order issues (when using ContextLoaderServlet, the root application context will get initialized after this filter).

  Since:
    1.2
  Author:
    Juergen Hoeller
  See Also:
    `setSingleSession(boolean)`, `setFlushMode(org.hibernate.FlushMode)`, `lookupSessionFactory(javax.servlet.http.HttpServletRequest)`, `OpenSessionInViewInterceptor`, `HibernateInterceptor`, `HibernateTransactionManager`, `SessionFactoryUtils.getSession(org.hibernate.SessionFactory, boolean)`, `TransactionSynchronizationManager`

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `DEFAULT_SESSION_FACTORY_BEAN_NAME`

    - ### Fields inherited from class org.springframework.web.filter.OncePerRequestFilter

      `ALREADY_FILTERED_SUFFIX`

    - ### Fields inherited from class org.springframework.web.filter.GenericFilterBean

      `logger`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `OpenSessionInViewFilter()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `closeSession(Session session, SessionFactory sessionFactory)` Close the given Session.
    `protected void` | `doFilterInternal(HttpServletRequest request, HttpServletResponse response, FilterChain filterChain)` Same contract as for `doFilter`, but guaranteed to be just invoked once per request within a single request thread.
    `protected FlushMode` | `getFlushMode()` Return the Hibernate FlushMode that this filter applies to its `Session` (in single session mode).
    `protected Session` | `getSession(SessionFactory sessionFactory)` Get a Session for the SessionFactory that this filter uses.
    `protected String` | `getSessionFactoryBeanName()` Return the bean name of the SessionFactory to fetch from Spring's root application context.
    `protected boolean` | `isSingleSession()` Return whether to use a single session for each request.
    `protected SessionFactory` | `lookupSessionFactory()` Look up the SessionFactory that this filter should use.
    `protected SessionFactory` | `lookupSessionFactory(HttpServletRequest request)` Look up the SessionFactory that this filter should use, taking the current HTTP request as argument.
    `void` | `setFlushMode(FlushMode flushMode)` Specify the Hibernate FlushMode to apply to this filter's `Session`.
    `void` | `setSessionFactoryBeanName(String sessionFactoryBeanName)` Set the bean name of the SessionFactory to fetch from Spring's root application context.
    `void` | `setSingleSession(boolean singleSession)` Set whether to use a single session for each request.
    `protected boolean` | `shouldNotFilterAsyncDispatch()` The default value is "false" so that the filter may re-bind the opened `Session` to each asynchronously dispatched thread and postpone closing it until the very last asynchronous dispatch.
    `protected boolean` | `shouldNotFilterErrorDispatch()` Returns "false" so that the filter may provide a Hibernate `Session` to each error dispatches.

    - ### Methods inherited from class org.springframework.web.filter.OncePerRequestFilter

      `doFilter, getAlreadyFilteredAttributeName, isAsyncDispatch, isAsyncStarted, shouldNotFilter`

    - ### Methods inherited from class org.springframework.web.filter.GenericFilterBean

      `addRequiredProperty, afterPropertiesSet, destroy, getFilterConfig, getFilterName, getServletContext, init, initBeanWrapper, initFilterBean, setBeanName, setEnvironment, setServletContext`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT_SESSION_FACTORY_BEAN_NAME

          public static final String DEFAULT_SESSION_FACTORY_BEAN_NAME

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### OpenSessionInViewFilter

          public OpenSessionInViewFilter()

  - ### Method Detail

    - #### setSessionFactoryBeanName

          public void setSessionFactoryBeanName(String sessionFactoryBeanName)

      Set the bean name of the SessionFactory to fetch from Spring's root application context. Default is "sessionFactory".
      See Also:
        `DEFAULT_SESSION_FACTORY_BEAN_NAME`

    - #### getSessionFactoryBeanName

          protected String getSessionFactoryBeanName()

      Return the bean name of the SessionFactory to fetch from Spring's root application context.

    - #### setSingleSession

          public void setSingleSession(boolean singleSession)

      Set whether to use a single session for each request. Default is "true".

      If set to "false", each data access operation or transaction will use its own session (like without Open Session in View). Each of those sessions will be registered for deferred close, though, actually processed at request completion.

      See Also:
        `SessionFactoryUtils.initDeferredClose(org.hibernate.SessionFactory)`, `SessionFactoryUtils.processDeferredClose(org.hibernate.SessionFactory)`

    - #### isSingleSession

          protected boolean isSingleSession()

      Return whether to use a single session for each request.

    - #### setFlushMode

          public void setFlushMode(FlushMode flushMode)

      Specify the Hibernate FlushMode to apply to this filter's `Session`. Only applied in single session mode.

      Can be populated with the corresponding constant name in XML bean definitions: e.g. "AUTO".

      The default is "MANUAL". Specify "AUTO" if you intend to use this filter without service layer transactions.

      See Also:
        `Session.setFlushMode(org.hibernate.FlushMode)`, `FlushMode.MANUAL`, `FlushMode.AUTO`

    - #### getFlushMode

          protected FlushMode getFlushMode()

      Return the Hibernate FlushMode that this filter applies to its `Session` (in single session mode).

    - #### shouldNotFilterAsyncDispatch

          protected boolean shouldNotFilterAsyncDispatch()

      The default value is "false" so that the filter may re-bind the opened `Session` to each asynchronously dispatched thread and postpone closing it until the very last asynchronous dispatch.
      Overrides:
        `shouldNotFilterAsyncDispatch` in class `OncePerRequestFilter`

    - #### shouldNotFilterErrorDispatch

          protected boolean shouldNotFilterErrorDispatch()

      Returns "false" so that the filter may provide a Hibernate `Session` to each error dispatches.
      Overrides:
        `shouldNotFilterErrorDispatch` in class `OncePerRequestFilter`

    - #### doFilterInternal

          protected void doFilterInternal(HttpServletRequest request,
                              HttpServletResponse response,
                              FilterChain filterChain)
                                   throws ServletException,
                                          IOException

      Description copied from class: `OncePerRequestFilter`
      Same contract as for `doFilter`, but guaranteed to be just invoked once per request within a single request thread. See `OncePerRequestFilter.shouldNotFilterAsyncDispatch()` for details.

      Provides HttpServletRequest and HttpServletResponse arguments instead of the default ServletRequest and ServletResponse ones.

      Specified by:
        `doFilterInternal` in class `OncePerRequestFilter`
      Throws:
        `ServletException`
        `IOException`

    - #### lookupSessionFactory

          protected SessionFactory lookupSessionFactory(HttpServletRequest request)

      Look up the SessionFactory that this filter should use, taking the current HTTP request as argument.

      The default implementation delegates to the `lookupSessionFactory()` variant without arguments.

      Parameters:
        `request` - the current request
      Returns:
        the SessionFactory to use

    - #### lookupSessionFactory

          protected SessionFactory lookupSessionFactory()

      Look up the SessionFactory that this filter should use.

      The default implementation looks for a bean with the specified name in Spring's root application context.

      Returns:
        the SessionFactory to use
      See Also:
        `getSessionFactoryBeanName()`

    - #### getSession

          protected Session getSession(SessionFactory sessionFactory)
                                throws DataAccessResourceFailureException

      Get a Session for the SessionFactory that this filter uses. Note that this just applies in single session mode!

      The default implementation delegates to the `SessionFactoryUtils.getSession` method and sets the `Session`'s flush mode to "MANUAL".

      Can be overridden in subclasses for creating a Session with a custom entity interceptor or JDBC exception translator.

      Parameters:
        `sessionFactory` - the SessionFactory that this filter uses
      Returns:
        the Session to use
      Throws:
        `DataAccessResourceFailureException` - if the Session could not be created
      See Also:
        `SessionFactoryUtils.getSession(SessionFactory, boolean)`, `FlushMode.MANUAL`

    - #### closeSession

          protected void closeSession(Session session,
                          SessionFactory sessionFactory)

      Close the given Session. Note that this just applies in single session mode!

      Can be overridden in subclasses, e.g. for flushing the Session before closing it. See class-level javadoc for a discussion of flush handling. Note that you should also override getSession accordingly, to set the flush mode to something else than NEVER.

      Parameters:
        `session` - the Session used for filtering
        `sessionFactory` - the SessionFactory that this filter uses